---
title: '@property'
slug: Web/CSS/@property
tags:
  - At-rule
  - CSS
  - Reference
  - Web
  - Property
  - Houdini
---
<div>{{CSSRef}}{{SeeCompatTable}}</div>

<p>The <strong><code>@property</code></strong> <a href="/en/CSS" title="CSS">CSS</a> <a href="/en/CSS/At-rule" title="At-rule">at-rule</a> is part of the <a href="/en-US/docs/Web/Houdini">CSS Houdini</a> umbrella of APIs, it allows developers to explicitly define their {{cssxref('--*', 'CSS custom properties')}}, allowing for property type checking, setting default values, and define whether a property can inherit values or not.</p>

<p>The <code>@property</code> rule represents a custom property registration directly in a stylesheet without having to run any JS. Valid <code>@property</code> rules result in a registered custom property, as if {{domxref('CSS.registerProperty')}} had been called with equivalent parameters.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: css no-line-numbers notranslate">@property --propery-name {
  syntax: '&lt;color&gt;';
  inherits: false;
  initial-value: #c0ffee;
}</pre>

<p>A valid <code>@property</code> rule represents a custom property registration, with the property name being the serialization of the in the rule’s prelude.</p>

<p><code>@property</code> rules require a <strong>syntax</strong> and <strong>inherits</strong> descriptor; if either are missing, the entire rule is invalid and must be ignored. The <strong>initial-value</strong> descriptor is optional only if the syntax is the universal syntax definition, otherwise the descriptor is required; if it’s missing, the entire rule is invalid and must be ignored.</p>

<p>Unknown descriptors are invalid and ignored, but do not invalidate the <code>@property</code> rule.</p>

<h2 id="Examples">Examples</h2>

<p>Add type checking to <code>--my-color</code> {{cssxref('--*', 'custom property')}}, as a color, a default value, and not allow it to inherit its value:</p>

<p>Using <a href="/en-US/docs/Web/CSS">CSS</a> {{cssxref('@property')}} <a href="/en-US/docs/Web/CSS/At-rule">at-rule</a>:</p>

<pre class="brush: css notranslate">@property --my-color {
  syntax: '&lt;color&gt;';
  inherits: false;
  initial-value: #c0ffee;
}
</pre>

<p>Using <a href="/en-US/docs/Web/JavaScript">JavaScript</a> {{domxref('CSS.registerProperty')}}:</p>

<pre class="brush: js notranslate">window.CSS.registerProperty({
  name: '--my-color',
  syntax: '&lt;color&gt;',
  inherits: false,
  initialValue: '#c0ffee',
});
</pre>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('CSS Properties and Values API', '#at-property-rule')}}</td>
   <td>{{Spec2('CSS Properties and Values API')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a class="external" href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</div>

<p>{{Compat("css.at-rules.property")}}</p>

<h2 id="See_Also">See Also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/CSS_Properties_and_Values_API">CSS Properties and Values API</a></li>
 <li><a href="/en-US/docs/Web/API/CSS_Painting_API">CSS Painting API</a></li>
 <li><a href="/en-US/docs/Web/API/CSS_Typed_OM_API">CSS Typed Object Model</a></li>
 <li><a href="/en-US/docs/Web/Houdini">CSS Houdini</a></li>
</ul>
